package org.zipcoder.store;

import java.util.*;

public class MyHashMap implements MyMap{
    // final field that doesn't change for any object
    private static final int BUCKET_SIZE = 15;

    // instance field that can only be set once. It is different for every Object
    private final List<Entry>[] entries;

    public MyHashMap(){
        entries = new List[BUCKET_SIZE];

        for(int i = 0; i < BUCKET_SIZE; i++) {
            entries[i] = new ArrayList<>();
        }
    }

    @Override
    public int size() {
        int totalSize = 0;

        for(List<Entry> e: entries){
            totalSize += e.size();
        }
        return totalSize;
    }

    @Override
    public boolean isEmptry() {
        if(size() == 0) {
            return true;
        } else {
            return false;
        }
    }

    @Override
    public Cart get(User key) {
        List<Entry> bin = entries[bucketIndex(key)];
        int index = keyIndex(bin, key);

        if(index >= 0){
            return bin.get(keyIndex(bin, key)).getValue();
        }else return null;
    }

    @Override
    public void put(User key, Cart value) {
        entries[bucketIndex(key)].add(new Entry(key,value));
    }

    @Override
    public List<User> getKeys() {
        List<User> userList = new ArrayList<User>();
        for(List<Entry> entryList: entries){
            for(Entry entry: entryList){
                userList.add(entry.getKey());
            }
        }
        return userList;
    }

    @Override
    public List<Cart> getValues() {
        List<Cart> userCarts = new ArrayList<Cart>();
        for(List<Entry> entryList: entries){
            for(Entry entry: entryList){
                userCarts.add(entry.getValue());
            }
        }
        return userCarts;
    }

    @Override
    public Cart remove(User key) {
        List<Entry> bin = entries[bucketIndex(key)];
        Iterator<Entry> iterator = bin.iterator();

        Cart removedCart = null;

        while(iterator.hasNext()) {
            Entry entry = iterator.next();
            if (entry.getKey().equals(key)) {
                removedCart = entry.getValue();
                iterator.remove();
            }
        }
        return removedCart;
    }

    private int bucketIndex(User key){
        return Math.abs(key.hashCode()) % entries.length;
    }

    private int keyIndex(List<Entry> bin, User key) {
        int index = -1;
        for (int i = 0; i < bin.size(); i++) {
            if (bin.get(i).getKey().equals(key)) {
                index = i;
            }
        }
        return index;
    }
}
